unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, CPort, Buttons, ComCtrls, VrControls, VrHyperCtrls,
  jpeg, Grids;

type
  TfrmMain = class(TForm)
    ComPort: TComPort;
    Panel1: TPanel;
    cbbox_Port: TComboBox;
    Label1: TLabel;
    Label2: TLabel;
    cbbox_BaudRate: TComboBox;
    btConnect: TButton;
    Label3: TLabel;
    Panel2: TPanel;
    edt_SettingCmd: TEdit;
    bt_SendnRead: TBitBtn;
    mem_InformationWnd: TMemo;
    bt_Clear: TBitBtn;
    Label4: TLabel;
    gb_Send: TGroupBox;
    rdo_Send_LF: TRadioButton;
    rdo_Send_CR: TRadioButton;
    rdo_Send_No: TRadioButton;
    gb_Recv: TGroupBox;
    rdo_Receive_LF: TRadioButton;
    rdo_Receive_CR: TRadioButton;
    rdo_Receive_NOW: TRadioButton;
    tmrSendnRead: TTimer;
    bt_Send: TBitBtn;
    bt_Read: TBitBtn;
    chk_SendDP: TCheckBox;
    Panel3: TPanel;
    pc_Mother: TPageControl;
    pc_SCPI: TTabSheet;
    lb_SCPI_Cmd: TListBox;
    pc_Cycling: TTabSheet;
    Label6: TLabel;
    Label7: TLabel;
    grdPattenEdit: TStringGrid;
    bt_patOpen: TBitBtn;
    bt_patSave: TBitBtn;
    bt_patRun: TBitBtn;
    bt_patStop: TBitBtn;
    edtRunRec: TEdit;
    edtRunCyc: TEdit;
    pc_About: TTabSheet;
    Image1: TImage;
    WL_MA: TVrWebLabel;
    edtSeq_Number: TEdit;
    Label5: TLabel;
    edtSeq_Cycle: TEdit;
    Label8: TLabel;
    Bevel1: TBevel;
    strMemoTemp: TMemo;
    tmr_Pattern: TTimer;
    tmr_Delay: TTimer;
    OpenDlg: TOpenDialog;
    SaveDlg: TSaveDialog;
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    procedure btConnectClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cbbox_PortChange(Sender: TObject);
    procedure cbbox_BaudRateChange(Sender: TObject);
    procedure bt_ClearClick(Sender: TObject);
    procedure bt_SendnReadClick(Sender: TObject);
    procedure edt_SettingCmdKeyPress(Sender: TObject; var Key: Char);
    procedure rdo_Receive_LFClick(Sender: TObject);
    procedure ComPortRxChar(Sender: TObject; Count: Integer);
    procedure tmrSendnReadTimer(Sender: TObject);
    procedure bt_SendClick(Sender: TObject);
    procedure bt_ReadClick(Sender: TObject);
    procedure rdo_Receive_CRClick(Sender: TObject);
    procedure rdo_Receive_NOWClick(Sender: TObject);
    procedure lb_SCPI_CmdClick(Sender: TObject);
    procedure WL_MAClick(Sender: TObject);
    procedure bt_patRunClick(Sender: TObject);
    procedure bt_patStopClick(Sender: TObject);
    procedure bt_patOpenClick(Sender: TObject);
    procedure bt_patSaveClick(Sender: TObject);
    procedure tmr_DelayTimer(Sender: TObject);
    procedure tmr_PatternTimer(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure rdo_Send_CRClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    patSeqCycle: integer;
    patSeqNumber: integer;
    patSeqCycle_cnt: integer;
    patSeqNumber_cnt: integer;
    patSequence: integer;   // 0-ƹ͵ ƴ, 1-, 2-, 3-Measure, 4- Delay
    function Vol_Cur_Check(strVol,strCur:String):Boolean;
    function usrFilter(): String;
  public
    strMainPath: string;
    str_RXBuffer: String;
    str_TXBuffer: String;
    str_RXBackBuf: String;
    bol_rev: boolean; // ϷǸ  true
                      //̼ſϷ ¸ false
    bol_manual: boolean; //False  Auto(send & Read mode)
                         //True  Readư  infomation Window ȿö
  end;

var
  frmMain: TfrmMain;

implementation
uses Registry,TypInfo,ShellAPI;

{$R *.DFM}
/////////////////////////////////////////////////////////
///////////////  User Program Area  /////////////////////
/////////////////////////////////////////////////////////
function TFrmMain.usrFilter(): String;
var strTemp, getFilter: String;
    IntFilIndex, IntIndex, i, j: Integer;
    Count: Integer;
begin
  IntFilIndex:= 0;
  Count:= 0;
  strTemp:= SaveDlg.Filter;
  for i:=1 to length(SaveDlg.Filter) do
  begin
    if strTemp[i] = '*' then
    begin
      IntFilIndex:= IntFilIndex+1;
      IntIndex:= i+1;  //ڿ  ġ 
      if IntFilIndex = SaveDlg.FilterIndex then
      begin
        for j:=i+1 to length(SaveDlg.Filter) do
        begin
          Count:= Count+1;
          if strTemp[j] = '|' then
          begin
            getFilter:= copy(strTemp, IntIndex, Count-1);
            Result:= getFilter;
            exit;
          end
          else if j = length(strTemp) then
          begin
            getFilter:= copy(strTemp, IntIndex, Count);
            Result:= getFilter;
            exit;
          end;
        end;
      end;
    end;
  end;
end;

function TfrmMain.Vol_Cur_Check(strVol,strCur:String):Boolean;
var
  flVol,flCur: Real;
begin
  try
    flVol:= StrToFloat(strVol);
    flCur:= strToFloat(strCur);
  except
    MessageDlg('You should input the number in pattern grid.',mtError,[mbOk],0);
    result:= False;
    exit;
  end;
  result:= True;
end;

function SlopeTime_Check(strST:String):Boolean;
var W_ST:Word;
begin
  if (length(strST) > 5) or (length(strST) = 0) then
  begin
    MessageDlg('You should input The number between 1 and 5-Digit at Slope.',mtError,[mbOk],0);
    result:= False;
    exit;
  end
  else if length(strST) = 5 then
  begin
    try
      if (StrToInt(strST[1]) > 6) or
         ((StrToInt(strST[1]) = 6) and (strToInt(strST) > 60000)) then
      begin
        MessageDlg('You should input limit value between 0 and 60000(1min) at Slope.',mtError,[mbOk],0);
        result:= False;
        exit;
      end;
    except
      MessageDlg('You should input The number.',mtError,[mbOk],0);
      result:= False;
      exit;
    end;
  end;

  try
    W_ST:= StrToInt(strST);
  except
      MessageDlg('You should input The number.',mtError,[mbOk],0);
    result:= False;
    exit;
  end;
  result:= True;
end;

function Delay_Check(strDelay:String):Boolean;
var DW_Delay:DWord;
begin
  if (length(strDelay) > 7) or (length(strDelay) = 0) then
  begin
    MessageDlg('You should input the number of between 1 and 7-Digit in the delay.',mtError,[mbOk],0);
    result:= False;
    exit;
  end
  else if length(strDelay) = 7 then
  begin
    try
      if (StrToInt(strDelay[1]) > 8) or
         ((StrToInt(strDelay[1]) = 8) and (strToInt(strDelay) > 8640000)) then
      begin
        MessageDlg('You should input the limit value of between 0 and 8640000(24hours) in the delay.',mtError,[mbOk],0);
        result:= False;
        exit;
      end;
    except
      MessageDlg('You should input the number.',mtError,[mbOk],0);
      result:= False;
      exit;
    end;
  end;

  try
    DW_Delay:= StrToInt(strDelay);
  except
    MessageDlg('You should input the number',mtError,[mbOk],0);
    result:= False;
    exit;
  end;
  result:= True;
end;

procedure TfrmMain.FormActivate(Sender: TObject);
var
  Reg: TRegistry;
  i: integer;
begin
  str_RXBackBuf:= '';
  // Registry-key Ÿ Save OR Read
  Reg:= TRegistry.Create;
  Reg.RootKey:= HKEY_LOCAL_MACHINE;
  if not Reg.OpenKey('SOFTWARE\ODA Technologies\ComPort',False) then
  begin  // 
    try
      with Reg do
      begin
        OpenKey('SOFTWARE\ODA Technologies\ComPort',True);
        WriteString('Port','COM1');
        WriteString('BaudRate','br9600');
      end;
    finally
      Reg.Free;
    end;
    SetEnumProp(frmMain.ComPort,'BaudRate','br9600');
    ComPort.Port:= 'COM1';
    cbbox_Port.Text:= 'COM1';
    cbbox_BaudRate.Text:= 'br9600';
//    PushConnect_Button:= False;
  end
  else
  begin
    frmMain.ComPort.Port:= Reg.ReadString('Port');
    SetEnumProp(frmMain.ComPort,'BaudRate',Reg.ReadString('BaudRate'));
    cbbox_Port.Text:= Reg.ReadString('Port');
    cbbox_BaudRate.Text:= Reg.ReadString('BaudRate');
  end;

  if ComPort.Connected then     //Com  ƴٸ....
  begin
    cbbox_Port.Enabled:= False;
    cbbox_BaudRate.Enabled:= False;
    btConnect.Caption:= 'DisConnect';
  end
  else                                 //Com  ȵƴٸ ...
  begin
    cbbox_Port.Enabled:= True;
    cbbox_BaudRate.Enabled:= True;
    btConnect.Caption:= 'Connect';
  end;

  //** Cycling mode  ʱȭ **//
  strMainPath:= ExtractFilePath(Application.ExeName);
  patSequence:= 0;
  str_RXBuffer:= '';
  str_TXBuffer:= '';
  for i:=1 to 1001 do
  begin
    grdPattenEdit.Cells[0,i]:= IntToStr(i);
    grdPattenEdit.Cells[1,i]:= '00.000';
    grdPattenEdit.Cells[2,i]:= '0.0000';
    grdPattenEdit.Cells[3,i]:= '0';
//    grdPattenEdit.Cells[4,i]:= '0';
  end;
  with grdPattenEdit do
  begin
    Cells[0,0]:= 'Number';
    Cells[1,0]:= 'Voltage[V]';
    Cells[2,0]:= 'Current[A]';
//    Cells[3,0]:= 'SLOPE[1ms]';
    Cells[3,0]:= 'Delay[ms]+100ms';
  end;

end;

procedure TfrmMain.btConnectClick(Sender: TObject);
var
  Reg: TRegistry;
begin
  if btConnect.Caption = 'Connect' then
  begin
    try
      ComPort.Open;
      btConnect.Caption:= 'DisConnect';
      cbbox_Port.Enabled:= False;
      cbbox_BaudRate.Enabled:= False;

      // Registry  Data 
      with Reg do
      begin
        Reg:= TRegistry.Create;
        Reg.RootKey:= HKEY_LOCAL_MACHINE;
        OpenKey('SOFTWARE\ODA Technologies\ComPort',True);
        WriteString('Port',cbbox_Port.Text);
        WriteString('BaudRate',cbbox_BaudRate.Text);
      end;
    except
      MessageDlg('You Can`t open ' + cbbox_Port.Text +'.'
          + #13 + cbbox_Port.Text + ' is already opened or You should exchange setting!',mtError,[mbOk],0);
    end;
  end
  else
  begin
    ComPort.Close;
    btConnect.Caption:= 'Connect';
    cbbox_Port.Enabled:= True;
    cbbox_BaudRate.Enabled:= True;
  end
end;


procedure TfrmMain.cbbox_PortChange(Sender: TObject);
begin
  ComPort.Port:= cbbox_Port.Text;
end;

procedure TfrmMain.cbbox_BaudRateChange(Sender: TObject);
begin
  SetEnumProp(ComPort,'BaudRate',cbbox_BaudRate.Text);
end;

procedure TfrmMain.bt_ClearClick(Sender: TObject);
begin
  mem_InformationWnd.Clear;
end;

procedure TfrmMain.bt_SendnReadClick(Sender: TObject);
begin
  if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  str_RXBuffer:= '';
  if rdo_Send_LF.Checked then
  begin
    ComPort.WriteStr(edt_SettingCmd.text+#10);
  end
  else if rdo_Send_CR.Checked then
  begin
    ComPort.WriteStr(edt_SettingCmd.text+#13);
  end
  else
  begin
    ComPort.WriteStr(edt_SettingCmd.text);
  end;
  if chk_SendDP.Checked then mem_InformationWnd.Lines.Add('-> ' + edt_SettingCmd.text);
  if rdo_Receive_NOW.Checked then exit; //ö Ÿ̸ ϰ,   ǥ
  bol_rev:= False;
  bol_manual:= False;

  bt_SendnRead.Enabled:= False;
  bt_Send.Enabled:= False;
  bt_Read.Enabled:= False;
  tmrSendnRead.Enabled:= True; // 5ʾȿ Timer Ѿ Ѵ.
                               // ׷  timeout error ߻ 
end;

procedure TfrmMain.edt_SettingCmdKeyPress(Sender: TObject; var Key: Char);
begin
{
  if Key = #13 then
  begin
    bt_SendnReadClick(nil);
    edt_SettingCmd.SelectAll();
  end;
}
end;

procedure TfrmMain.rdo_Receive_LFClick(Sender: TObject);
begin
  bt_Send.Enabled:= True;  // ¿  send & read
  bt_Read.Enabled:= True;
end;

procedure TfrmMain.rdo_Receive_CRClick(Sender: TObject);
begin
  bt_Send.Enabled:= True;  // ¿  send & read
  bt_Read.Enabled:= True;
end;

procedure TfrmMain.rdo_Receive_NOWClick(Sender: TObject);
begin
  bol_manual:= False; //Auto 
  bt_Send.Enabled:= False;  // ¿  send & read
  bt_Read.Enabled:= False;
end;

procedure TfrmMain.ComPortRxChar(Sender: TObject; Count: Integer);
var str,strTemp: String;
begin
  ComPort.ReadStr(str,count);
  // LFṮ
  if rdo_Receive_LF.Checked then
  begin
    if str[count] = #10 then
    begin
      tmrSendnRead.Enabled:= False; // readding  ưȰȭ
      bt_SendnRead.Enabled:= True;
      bt_Send.Enabled:= True;
      bt_Read.Enabled:= True;

      bol_rev:= True;
      // Send & Read¶ ӽ ۿ ͸ ϰ ִ´.
      if bol_manual then str_RXBackBuf:= str_RXBackBuf + ('<- ' +str_RXBuffer+str)
      else mem_InformationWnd.Lines.Add('<- ' +str_RXBuffer+str);
      str_RXBuffer := '';
    end
    else
      str_RXBuffer := str_RXBuffer + str;
  end
  //CRṮ
  else if rdo_Receive_CR.Checked then
  begin
    if str[count] = #13 then
    begin
      tmrSendnRead.Enabled:= False; // readding  ưȰȭ
      bt_SendnRead.Enabled:= True;
      bt_Send.Enabled:= True;
      bt_Read.Enabled:= True;

      bol_rev:= True;
      if bol_manual then str_RXBackBuf:= str_RXBackBuf + ('<- ' +str_RXBuffer+str)
      else mem_InformationWnd.Lines.Add('<- '+str_RXBuffer+str);
      str_RXBuffer := '';
    end
    else
      str_RXBuffer := str_RXBuffer + str;
  end
  //
  else if rdo_Receive_NOW.Checked then
  begin
{
    tmrSendnRead.Enabled:= False; // readding  ưȰȭ
    bt_SendnRead.Enabled:= True;
    bt_Send.Enabled:= True;
    bt_Read.Enabled:= True;

    bol_rev:= True;
}
    mem_InformationWnd.Text:= mem_InformationWnd.Text + str;
  end
end;

procedure TfrmMain.tmrSendnReadTimer(Sender: TObject);
begin
  tmrSendnRead.Enabled:= False;
  MessageDlg('A timeout occurred',mtError,[mbOk],0);
  bt_SendnRead.Enabled:= True;
  bt_Send.Enabled:= True;
  bt_Read.Enabled:= True;
  str_RXBuffer:= '';
end;

procedure TfrmMain.bt_SendClick(Sender: TObject);
begin
  if ComPort.Connected = False then
  begin
    MessageDlg('Comm Port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  str_RXBuffer:= '';
  bol_rev:= False;
  bol_manual:= True;
  if rdo_Send_LF.Checked then
  begin
    ComPort.WriteStr(edt_SettingCmd.text+#10);
//    mem_InformationWnd.Lines.Add('lf');
  end
  else if rdo_Send_CR.Checked then
  begin
    ComPort.WriteStr(edt_SettingCmd.text+#13);
//    mem_InformationWnd.Lines.Add('cr');
  end
  else
  begin
    ComPort.WriteStr(edt_SettingCmd.text);
  end;
  if chk_SendDP.Checked then mem_InformationWnd.Lines.Add('-> ' + edt_SettingCmd.text);
end;

procedure TfrmMain.bt_ReadClick(Sender: TObject);
begin
  if bol_rev then
  begin
    mem_InformationWnd.Lines.Add(str_RXBackBuf);
    str_RXBackBuf:= '';
    bol_rev:= False;
  end
  else  //ſϷᰡ ȵȻ¶... Ÿ̸ 5ʰ
  begin
    tmrSendnRead.Enabled:= True;
    bt_SendnRead.Enabled:= False;
    bt_Send.Enabled:= False;
    bt_Read.Enabled:= False;
  end;

end;



procedure TfrmMain.lb_SCPI_CmdClick(Sender: TObject);
begin
  edt_SettingCmd.Text:= lb_SCPI_Cmd.Items.Strings[lb_SCPI_Cmd.ItemIndex];
end;

procedure TfrmMain.WL_MAClick(Sender: TObject);
begin
  WL_MA.URL := 'http://www.odacore.com/';
end;

procedure TfrmMain.bt_patRunClick(Sender: TObject);
var i, j:integer;
begin
  if ComPort.Connected = False then
  begin
    MessageDlg('Com port hasn''t been initialized!',mtWarning,[mbOk],0);
    exit;
  end;
  // Sequence Number  üũ
  try
    patSeqNumber:= StrToInt(edtSeq_Number.Text);
    if (patSeqNumber < 1) or (patSeqNumber > 1000) then   //1000EA
    begin
      MessageDlg('You should input limit value of between 1 and 1000 in the sequence number.',mtError,[mbOk],0);
      exit;
    end;
  except
    MessageDlg('You should input the number.',mtError,[mbOk],0);
    exit;
  end;
  // Sequence Cycle  üũ
  if (length(edtSeq_Cycle.Text) > 5) or (length(edtSeq_Cycle.Text) = 0) then
  begin
    MessageDlg('You should input the number of between 1 and 5-Digit in the sequence cycle.',mtError,[mbOk],0);
    exit;
  end
  else if length(edtSeq_Cycle.Text) = 5 then
  begin
    try
      if (StrToInt(edtSeq_Cycle.Text[1]) > 6) or
         ((StrToInt(edtSeq_Cycle.Text[1]) = 6) and (strToInt(edtSeq_Cycle.Text) > 60000)) then
      begin
        MessageDlg('You should input limit value of between 1 and 60000 in the sequence cycle.',mtError,[mbOk],0);
        exit;
      end;
    except
      MessageDlg('You should input the number.',mtError,[mbOk],0);
      exit;
    end;
  end;
  try
    patSeqCycle:= StrToInt(edtSeq_Cycle.Text);
    if patSeqCycle = 0 then
    begin
      MessageDlg('You should input limit value of between 1 and 60000 in the sequence cycle.',mtError,[mbOk],0);
      exit;
    end;
  except
    MessageDlg('You should input the number.' + IntToStr(i+1),mtError,[mbOk],0);
    exit;
  end;
  // Patten Edit List      Error Check
  i:= 0;
  while(i < patSeqNumber)do
  begin
    if not Vol_Cur_Check(grdPattenEdit.Cells[1,i+1],grdPattenEdit.Cells[2,i+1]) then
    begin
      MessageDlg('volt curr Error Record Number = ' + IntToStr(i+1),mtInformation,[mbOk],0);
      exit;
    end;
    if not Delay_Check(grdpattenEdit.Cells[3,i+1]) then
    begin
      MessageDlg('delay Error Record Number = ' + IntToStr(i+1),mtInformation,[mbOk],0);
      exit;
    end;
    i:= i+1;
  end;
  bt_SendnRead.Enabled:= False;
  bt_Send.Enabled:= False;
  bt_Read.Enabled:= False;
  gb_Recv.Enabled:= False;
  gb_Send.Enabled:= False;

  bt_patRun.Enabled:= False;
  bt_patStop.Enabled:= True;
  grdPattenEdit.Enabled:= False;
  edtRunRec.Text:= '0';
  edtRunCyc.Text:= '0';
  patSeqNumber_cnt:= 0;
  patSeqCycle_cnt:= 0;
  patSequence:= 1;                     //м
  tmr_Pattern.Enabled:= True;          //Pattern 
end;

procedure TfrmMain.bt_patStopClick(Sender: TObject);
begin
  tmr_Pattern.Enabled:= False;
  tmr_Delay.Enabled:= False;
  bt_patRun.Enabled:= True;
  grdPattenEdit.Enabled:= True;

  bt_SendnRead.Enabled:= True;
  bt_Send.Enabled:= True;
  bt_Read.Enabled:= True;
  gb_Recv.Enabled:= True;
  gb_Send.Enabled:= True;
end;

procedure TfrmMain.bt_patOpenClick(Sender: TObject);
var i,j,Count: integer;
begin
  if OpenDlg.Execute then
  begin
    strMemoTemp.Lines.LoadFromFile(OpenDlg.FileName);
    Count:= 0;
    for i:= 1 to 1000 do
    begin
      for j:= 0 to 3 do
      begin
        grdPattenEdit.Cells[j,i]:= strMemoTemp.Lines.Strings[Count];
        Inc(Count);
      end;
      inc(Count);
    end;
  edtSeq_Number.Text:= strMemoTemp.Lines.Strings[Count];
  edtSeq_Cycle.Text:= strMemoTemp.Lines.Strings[Count+1];
  end;
end;

procedure TfrmMain.bt_patSaveClick(Sender: TObject);
var strPatternPath: String;
    i: integer;
begin
  if SaveDlg.Execute then
  begin
    if ExtractFileExt(saveDlg.FileName) = '' then
      strPatternPath:= SaveDlg.FileName + usrFilter()
    else
      strPatternPath:= SaveDlg.FileName;
    if FileExists(strPatternPath) then
    begin
      if MessageDlg(Format('%s' + #13 + 'The file already exists.' + #13 + 'Replace existing file?', [strPatternPath]),
        mtWarning, [mbYes,mbNo], 0) <> idYes then Exit;
    end;
    strMemoTemp.Lines.Clear;
    for i:= 1 to 1000 do
    begin
      strMemoTemp.Lines.Add(grdPattenEdit.Rows[i].GetText);
    end;
    with strMemoTemp.Lines do
    begin
      Add(edtSeq_Number.Text);
      Add(edtSeq_Cycle.Text);
      SaveToFile(strPatternPath);
    end;
  end;
end;

procedure TfrmMain.tmr_DelayTimer(Sender: TObject);
begin
  if patSeqCycle <> patSeqCycle_cnt then
    tmr_Pattern.Enabled:= True
  else
  begin
    bt_patRun.Enabled:= True;
    bt_patStop.Enabled:= False;
    grdPattenEdit.Enabled:= True;

    bt_SendnRead.Enabled:= True;
    bt_Send.Enabled:= True;
    bt_Read.Enabled:= True;
    gb_Recv.Enabled:= True;
    gb_Send.Enabled:= True;
  end;
end;

procedure TfrmMain.tmr_PatternTimer(Sender: TObject);
var intTemp: integer;
begin
  edtRunRec.Text:= IntToStr(patSeqNumber_cnt+1);
  str_TXBuffer:= 'Appl '+ grdPattenEdit.Cells[1,patSeqNumber_cnt+1] + ','+
                          grdPattenEdit.Cells[2,patSeqNumber_cnt+1] + #10;

  tmr_Pattern.Enabled:= False;
  patSequence:= 1;
  inc(patSeqNumber_cnt);
  if patSeqNumber = patSeqNumber_cnt then
  begin
    patSeqNumber_cnt:= 0;
    inc(patSeqCycle_cnt);
    edtRunCyc.Text:=  IntToStr(patSeqCycle_cnt);
  end;

  intTemp:= StrToInt(grdPattenEdit.Cells[3,patSeqNumber_cnt+1]);
  if intTemp = 0 then
  begin
    if patSeqCycle <> patSeqCycle_cnt then
      tmr_Pattern.Enabled:= True
    else
    begin
      bt_patRun.Enabled:= True;
      bt_patStop.Enabled:= False;
      grdPattenEdit.Enabled:= True;
      
      bt_SendnRead.Enabled:= True;
      bt_Send.Enabled:= True;
      bt_Read.Enabled:= True;
      gb_Recv.Enabled:= True;
      gb_Send.Enabled:= True;
    end;
  end
  else
  begin
    tmr_Delay.Interval:= intTemp;
    tmr_delay.Enabled:= True;
  end;
//    exit;
//  end;
  if chk_SendDP.Checked then mem_InformationWnd.Lines.Add('-> '+str_TXBuffer);
  ComPort.WriteStr(str_TXBuffer);
end;

procedure TfrmMain.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TfrmMain.rdo_Send_CRClick(Sender: TObject);
begin
  mem_InformationWnd.Lines.Add('ODA Technologies programmable power supply RS232   LF մϴ.');
end;

procedure TfrmMain.SpeedButton1Click(Sender: TObject);
begin
  ShellExecute(Application.Handle, 'open', PChar(strMainPath +
                  'Document\manual.pdf'),nil, PChar('C:'), SW_SHOW);
end;

end.

